import { A } from '@solidjs/router';
import PouchDb from 'pouchdb';
import { Component, createEffect, For } from 'solid-js';
import { createServerAction$ } from 'solid-start/server';

interface Props {}

const Invitations: Component<Props> = (props) => {
  const [invitations, getInvitations] = createServerAction$(
    async (values: any) => {
      const db = new PouchDb('.db');
      const results = await db.allDocs({
        include_docs: true,
        startkey: 'invitation/',
        endkey: 'invitation/\ufff0',
      });
      console.log({ caller: 'Invitations / serverAction', results });
      return results.rows;
    }
  );

  getInvitations();

  createEffect(() => {
    console.log({
      caller: 'Invitations',
      invitations: invitations.result,
    });
  });

  return (
    <ul>
      <For each={invitations.result}>
        {(invitation: any) => {
          console.log({
            caller: 'Invitations / loop',
            invitations: invitation,
          });
          return (
            <li>
              <A href={encodeURIComponent(invitation.id)}>{invitation.doc.mail}</A>
            </li>
          );
        }}
      </For>
    </ul>
  );
};

export default Invitations;
